# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetComputeCapacityTopologyComputeHpcIslandsResult',
    'AwaitableGetComputeCapacityTopologyComputeHpcIslandsResult',
    'get_compute_capacity_topology_compute_hpc_islands',
    'get_compute_capacity_topology_compute_hpc_islands_output',
]

@pulumi.output_type
class GetComputeCapacityTopologyComputeHpcIslandsResult:
    """
    A collection of values returned by getComputeCapacityTopologyComputeHpcIslands.
    """
    def __init__(__self__, availability_domain=None, compartment_id=None, compute_capacity_topology_id=None, compute_hpc_island_collections=None, filters=None, id=None):
        if availability_domain and not isinstance(availability_domain, str):
            raise TypeError("Expected argument 'availability_domain' to be a str")
        pulumi.set(__self__, "availability_domain", availability_domain)
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if compute_capacity_topology_id and not isinstance(compute_capacity_topology_id, str):
            raise TypeError("Expected argument 'compute_capacity_topology_id' to be a str")
        pulumi.set(__self__, "compute_capacity_topology_id", compute_capacity_topology_id)
        if compute_hpc_island_collections and not isinstance(compute_hpc_island_collections, list):
            raise TypeError("Expected argument 'compute_hpc_island_collections' to be a list")
        pulumi.set(__self__, "compute_hpc_island_collections", compute_hpc_island_collections)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="availabilityDomain")
    def availability_domain(self) -> Optional[str]:
        return pulumi.get(self, "availability_domain")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> Optional[str]:
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="computeCapacityTopologyId")
    def compute_capacity_topology_id(self) -> str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compute capacity topology.
        """
        return pulumi.get(self, "compute_capacity_topology_id")

    @property
    @pulumi.getter(name="computeHpcIslandCollections")
    def compute_hpc_island_collections(self) -> Sequence['outputs.GetComputeCapacityTopologyComputeHpcIslandsComputeHpcIslandCollectionResult']:
        """
        The list of compute_hpc_island_collection.
        """
        return pulumi.get(self, "compute_hpc_island_collections")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetComputeCapacityTopologyComputeHpcIslandsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetComputeCapacityTopologyComputeHpcIslandsResult(GetComputeCapacityTopologyComputeHpcIslandsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetComputeCapacityTopologyComputeHpcIslandsResult(
            availability_domain=self.availability_domain,
            compartment_id=self.compartment_id,
            compute_capacity_topology_id=self.compute_capacity_topology_id,
            compute_hpc_island_collections=self.compute_hpc_island_collections,
            filters=self.filters,
            id=self.id)


def get_compute_capacity_topology_compute_hpc_islands(availability_domain: Optional[str] = None,
                                                      compartment_id: Optional[str] = None,
                                                      compute_capacity_topology_id: Optional[str] = None,
                                                      filters: Optional[Sequence[pulumi.InputType['GetComputeCapacityTopologyComputeHpcIslandsFilterArgs']]] = None,
                                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetComputeCapacityTopologyComputeHpcIslandsResult:
    """
    This data source provides the list of Compute Capacity Topology Compute Hpc Islands in Oracle Cloud Infrastructure Core service.

    Lists compute HPC islands in the specified compute capacity topology.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_compute_capacity_topology_compute_hpc_islands = oci.Core.get_compute_capacity_topology_compute_hpc_islands(compute_capacity_topology_id=test_compute_capacity_topology["id"],
        availability_domain=compute_capacity_topology_compute_hpc_island_availability_domain,
        compartment_id=compartment_id)
    ```


    :param str availability_domain: The name of the availability domain.  Example: `Uocm:PHX-AD-1`
    :param str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param str compute_capacity_topology_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compute capacity topology.
    """
    __args__ = dict()
    __args__['availabilityDomain'] = availability_domain
    __args__['compartmentId'] = compartment_id
    __args__['computeCapacityTopologyId'] = compute_capacity_topology_id
    __args__['filters'] = filters
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:Core/getComputeCapacityTopologyComputeHpcIslands:getComputeCapacityTopologyComputeHpcIslands', __args__, opts=opts, typ=GetComputeCapacityTopologyComputeHpcIslandsResult).value

    return AwaitableGetComputeCapacityTopologyComputeHpcIslandsResult(
        availability_domain=pulumi.get(__ret__, 'availability_domain'),
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        compute_capacity_topology_id=pulumi.get(__ret__, 'compute_capacity_topology_id'),
        compute_hpc_island_collections=pulumi.get(__ret__, 'compute_hpc_island_collections'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'))


@_utilities.lift_output_func(get_compute_capacity_topology_compute_hpc_islands)
def get_compute_capacity_topology_compute_hpc_islands_output(availability_domain: Optional[pulumi.Input[Optional[str]]] = None,
                                                             compartment_id: Optional[pulumi.Input[Optional[str]]] = None,
                                                             compute_capacity_topology_id: Optional[pulumi.Input[str]] = None,
                                                             filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetComputeCapacityTopologyComputeHpcIslandsFilterArgs']]]]] = None,
                                                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetComputeCapacityTopologyComputeHpcIslandsResult]:
    """
    This data source provides the list of Compute Capacity Topology Compute Hpc Islands in Oracle Cloud Infrastructure Core service.

    Lists compute HPC islands in the specified compute capacity topology.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_compute_capacity_topology_compute_hpc_islands = oci.Core.get_compute_capacity_topology_compute_hpc_islands(compute_capacity_topology_id=test_compute_capacity_topology["id"],
        availability_domain=compute_capacity_topology_compute_hpc_island_availability_domain,
        compartment_id=compartment_id)
    ```


    :param str availability_domain: The name of the availability domain.  Example: `Uocm:PHX-AD-1`
    :param str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param str compute_capacity_topology_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compute capacity topology.
    """
    ...
