# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DeployArtifactArgs', 'DeployArtifact']

@pulumi.input_type
class DeployArtifactArgs:
    def __init__(__self__, *,
                 argument_substitution_mode: pulumi.Input[str],
                 deploy_artifact_source: pulumi.Input['DeployArtifactDeployArtifactSourceArgs'],
                 deploy_artifact_type: pulumi.Input[str],
                 project_id: pulumi.Input[str],
                 defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None):
        """
        The set of arguments for constructing a DeployArtifact resource.
        :param pulumi.Input[str] argument_substitution_mode: (Updatable) Mode for artifact parameter substitution. Options: `"NONE", "SUBSTITUTE_PLACEHOLDERS"` For Helm Deployments only "NONE" is supported.
        :param pulumi.Input['DeployArtifactDeployArtifactSourceArgs'] deploy_artifact_source: (Updatable) Specifies source of an artifact.
        :param pulumi.Input[str] deploy_artifact_type: (Updatable) Type of the deployment artifact.
        :param pulumi.Input[str] project_id: The OCID of a project.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[Mapping[str, Any]] defined_tags: (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"foo-namespace.bar-key": "value"}`
        :param pulumi.Input[str] description: (Updatable) Optional description about the deployment artifact.
        :param pulumi.Input[str] display_name: (Updatable) Deployment artifact display name. Avoid entering confidential information.
        :param pulumi.Input[Mapping[str, Any]] freeform_tags: (Updatable) Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.  See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"bar-key": "value"}`
        """
        pulumi.set(__self__, "argument_substitution_mode", argument_substitution_mode)
        pulumi.set(__self__, "deploy_artifact_source", deploy_artifact_source)
        pulumi.set(__self__, "deploy_artifact_type", deploy_artifact_type)
        pulumi.set(__self__, "project_id", project_id)
        if defined_tags is not None:
            pulumi.set(__self__, "defined_tags", defined_tags)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if freeform_tags is not None:
            pulumi.set(__self__, "freeform_tags", freeform_tags)

    @property
    @pulumi.getter(name="argumentSubstitutionMode")
    def argument_substitution_mode(self) -> pulumi.Input[str]:
        """
        (Updatable) Mode for artifact parameter substitution. Options: `"NONE", "SUBSTITUTE_PLACEHOLDERS"` For Helm Deployments only "NONE" is supported.
        """
        return pulumi.get(self, "argument_substitution_mode")

    @argument_substitution_mode.setter
    def argument_substitution_mode(self, value: pulumi.Input[str]):
        pulumi.set(self, "argument_substitution_mode", value)

    @property
    @pulumi.getter(name="deployArtifactSource")
    def deploy_artifact_source(self) -> pulumi.Input['DeployArtifactDeployArtifactSourceArgs']:
        """
        (Updatable) Specifies source of an artifact.
        """
        return pulumi.get(self, "deploy_artifact_source")

    @deploy_artifact_source.setter
    def deploy_artifact_source(self, value: pulumi.Input['DeployArtifactDeployArtifactSourceArgs']):
        pulumi.set(self, "deploy_artifact_source", value)

    @property
    @pulumi.getter(name="deployArtifactType")
    def deploy_artifact_type(self) -> pulumi.Input[str]:
        """
        (Updatable) Type of the deployment artifact.
        """
        return pulumi.get(self, "deploy_artifact_type")

    @deploy_artifact_type.setter
    def deploy_artifact_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "deploy_artifact_type", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[str]:
        """
        The OCID of a project.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"foo-namespace.bar-key": "value"}`
        """
        return pulumi.get(self, "defined_tags")

    @defined_tags.setter
    def defined_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "defined_tags", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        (Updatable) Optional description about the deployment artifact.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        (Updatable) Deployment artifact display name. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        (Updatable) Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.  See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"bar-key": "value"}`
        """
        return pulumi.get(self, "freeform_tags")

    @freeform_tags.setter
    def freeform_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "freeform_tags", value)


@pulumi.input_type
class _DeployArtifactState:
    def __init__(__self__, *,
                 argument_substitution_mode: Optional[pulumi.Input[str]] = None,
                 compartment_id: Optional[pulumi.Input[str]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 deploy_artifact_source: Optional[pulumi.Input['DeployArtifactDeployArtifactSourceArgs']] = None,
                 deploy_artifact_type: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 lifecycle_details: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 system_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 time_created: Optional[pulumi.Input[str]] = None,
                 time_updated: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering DeployArtifact resources.
        :param pulumi.Input[str] argument_substitution_mode: (Updatable) Mode for artifact parameter substitution. Options: `"NONE", "SUBSTITUTE_PLACEHOLDERS"` For Helm Deployments only "NONE" is supported.
        :param pulumi.Input[str] compartment_id: The OCID of a compartment.
        :param pulumi.Input[Mapping[str, Any]] defined_tags: (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"foo-namespace.bar-key": "value"}`
        :param pulumi.Input['DeployArtifactDeployArtifactSourceArgs'] deploy_artifact_source: (Updatable) Specifies source of an artifact.
        :param pulumi.Input[str] deploy_artifact_type: (Updatable) Type of the deployment artifact.
        :param pulumi.Input[str] description: (Updatable) Optional description about the deployment artifact.
        :param pulumi.Input[str] display_name: (Updatable) Deployment artifact display name. Avoid entering confidential information.
        :param pulumi.Input[Mapping[str, Any]] freeform_tags: (Updatable) Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.  See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"bar-key": "value"}`
        :param pulumi.Input[str] lifecycle_details: A detailed message describing the current state. For example, can be used to provide actionable information for a resource in Failed state.
        :param pulumi.Input[str] project_id: The OCID of a project.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[str] state: Current state of the deployment artifact.
        :param pulumi.Input[Mapping[str, Any]] system_tags: Usage of system tag keys. These predefined keys are scoped to namespaces. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"orcl-cloud.free-tier-retained": "true"}`
        :param pulumi.Input[str] time_created: Time the deployment artifact was created. Format defined by [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339).
        :param pulumi.Input[str] time_updated: Time the deployment artifact was updated. Format defined by [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339).
        """
        if argument_substitution_mode is not None:
            pulumi.set(__self__, "argument_substitution_mode", argument_substitution_mode)
        if compartment_id is not None:
            pulumi.set(__self__, "compartment_id", compartment_id)
        if defined_tags is not None:
            pulumi.set(__self__, "defined_tags", defined_tags)
        if deploy_artifact_source is not None:
            pulumi.set(__self__, "deploy_artifact_source", deploy_artifact_source)
        if deploy_artifact_type is not None:
            pulumi.set(__self__, "deploy_artifact_type", deploy_artifact_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if freeform_tags is not None:
            pulumi.set(__self__, "freeform_tags", freeform_tags)
        if lifecycle_details is not None:
            pulumi.set(__self__, "lifecycle_details", lifecycle_details)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if system_tags is not None:
            pulumi.set(__self__, "system_tags", system_tags)
        if time_created is not None:
            pulumi.set(__self__, "time_created", time_created)
        if time_updated is not None:
            pulumi.set(__self__, "time_updated", time_updated)

    @property
    @pulumi.getter(name="argumentSubstitutionMode")
    def argument_substitution_mode(self) -> Optional[pulumi.Input[str]]:
        """
        (Updatable) Mode for artifact parameter substitution. Options: `"NONE", "SUBSTITUTE_PLACEHOLDERS"` For Helm Deployments only "NONE" is supported.
        """
        return pulumi.get(self, "argument_substitution_mode")

    @argument_substitution_mode.setter
    def argument_substitution_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "argument_substitution_mode", value)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> Optional[pulumi.Input[str]]:
        """
        The OCID of a compartment.
        """
        return pulumi.get(self, "compartment_id")

    @compartment_id.setter
    def compartment_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "compartment_id", value)

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"foo-namespace.bar-key": "value"}`
        """
        return pulumi.get(self, "defined_tags")

    @defined_tags.setter
    def defined_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "defined_tags", value)

    @property
    @pulumi.getter(name="deployArtifactSource")
    def deploy_artifact_source(self) -> Optional[pulumi.Input['DeployArtifactDeployArtifactSourceArgs']]:
        """
        (Updatable) Specifies source of an artifact.
        """
        return pulumi.get(self, "deploy_artifact_source")

    @deploy_artifact_source.setter
    def deploy_artifact_source(self, value: Optional[pulumi.Input['DeployArtifactDeployArtifactSourceArgs']]):
        pulumi.set(self, "deploy_artifact_source", value)

    @property
    @pulumi.getter(name="deployArtifactType")
    def deploy_artifact_type(self) -> Optional[pulumi.Input[str]]:
        """
        (Updatable) Type of the deployment artifact.
        """
        return pulumi.get(self, "deploy_artifact_type")

    @deploy_artifact_type.setter
    def deploy_artifact_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "deploy_artifact_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        (Updatable) Optional description about the deployment artifact.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        (Updatable) Deployment artifact display name. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        (Updatable) Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.  See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"bar-key": "value"}`
        """
        return pulumi.get(self, "freeform_tags")

    @freeform_tags.setter
    def freeform_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "freeform_tags", value)

    @property
    @pulumi.getter(name="lifecycleDetails")
    def lifecycle_details(self) -> Optional[pulumi.Input[str]]:
        """
        A detailed message describing the current state. For example, can be used to provide actionable information for a resource in Failed state.
        """
        return pulumi.get(self, "lifecycle_details")

    @lifecycle_details.setter
    def lifecycle_details(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "lifecycle_details", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[str]]:
        """
        The OCID of a project.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        """
        Current state of the deployment artifact.
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter(name="systemTags")
    def system_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Usage of system tag keys. These predefined keys are scoped to namespaces. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"orcl-cloud.free-tier-retained": "true"}`
        """
        return pulumi.get(self, "system_tags")

    @system_tags.setter
    def system_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "system_tags", value)

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> Optional[pulumi.Input[str]]:
        """
        Time the deployment artifact was created. Format defined by [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339).
        """
        return pulumi.get(self, "time_created")

    @time_created.setter
    def time_created(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "time_created", value)

    @property
    @pulumi.getter(name="timeUpdated")
    def time_updated(self) -> Optional[pulumi.Input[str]]:
        """
        Time the deployment artifact was updated. Format defined by [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339).
        """
        return pulumi.get(self, "time_updated")

    @time_updated.setter
    def time_updated(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "time_updated", value)


class DeployArtifact(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 argument_substitution_mode: Optional[pulumi.Input[str]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 deploy_artifact_source: Optional[pulumi.Input[pulumi.InputType['DeployArtifactDeployArtifactSourceArgs']]] = None,
                 deploy_artifact_type: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 project_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource provides the Deploy Artifact resource in Oracle Cloud Infrastructure Devops service.

        Creates a new deployment artifact.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_deploy_artifact = oci.dev_ops.DeployArtifact("test_deploy_artifact",
            argument_substitution_mode=deploy_artifact_argument_substitution_mode,
            deploy_artifact_source=oci.dev_ops.DeployArtifactDeployArtifactSourceArgs(
                deploy_artifact_source_type=deploy_artifact_deploy_artifact_source_deploy_artifact_source_type,
                base64encoded_content=deploy_artifact_deploy_artifact_source_base64encoded_content,
                chart_url=deploy_artifact_deploy_artifact_source_chart_url,
                deploy_artifact_path=deploy_artifact_deploy_artifact_source_deploy_artifact_path,
                deploy_artifact_version=deploy_artifact_deploy_artifact_source_deploy_artifact_version,
                helm_artifact_source_type=deploy_artifact_deploy_artifact_source_helm_artifact_source_type,
                helm_verification_key_source=oci.dev_ops.DeployArtifactDeployArtifactSourceHelmVerificationKeySourceArgs(
                    verification_key_source_type=deploy_artifact_deploy_artifact_source_helm_verification_key_source_verification_key_source_type,
                    current_public_key=deploy_artifact_deploy_artifact_source_helm_verification_key_source_current_public_key,
                    previous_public_key=deploy_artifact_deploy_artifact_source_helm_verification_key_source_previous_public_key,
                    vault_secret_id=test_secret["id"],
                ),
                image_digest=deploy_artifact_deploy_artifact_source_image_digest,
                image_uri=deploy_artifact_deploy_artifact_source_image_uri,
                repository_id=test_repository["id"],
            ),
            deploy_artifact_type=deploy_artifact_deploy_artifact_type,
            project_id=test_project["id"],
            defined_tags={
                "foo-namespace.bar-key": "value",
            },
            description=deploy_artifact_description,
            display_name=deploy_artifact_display_name,
            freeform_tags={
                "bar-key": "value",
            })
        ```

        ## Import

        DeployArtifacts can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:DevOps/deployArtifact:DeployArtifact test_deploy_artifact "id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] argument_substitution_mode: (Updatable) Mode for artifact parameter substitution. Options: `"NONE", "SUBSTITUTE_PLACEHOLDERS"` For Helm Deployments only "NONE" is supported.
        :param pulumi.Input[Mapping[str, Any]] defined_tags: (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"foo-namespace.bar-key": "value"}`
        :param pulumi.Input[pulumi.InputType['DeployArtifactDeployArtifactSourceArgs']] deploy_artifact_source: (Updatable) Specifies source of an artifact.
        :param pulumi.Input[str] deploy_artifact_type: (Updatable) Type of the deployment artifact.
        :param pulumi.Input[str] description: (Updatable) Optional description about the deployment artifact.
        :param pulumi.Input[str] display_name: (Updatable) Deployment artifact display name. Avoid entering confidential information.
        :param pulumi.Input[Mapping[str, Any]] freeform_tags: (Updatable) Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.  See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"bar-key": "value"}`
        :param pulumi.Input[str] project_id: The OCID of a project.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DeployArtifactArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Deploy Artifact resource in Oracle Cloud Infrastructure Devops service.

        Creates a new deployment artifact.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_deploy_artifact = oci.dev_ops.DeployArtifact("test_deploy_artifact",
            argument_substitution_mode=deploy_artifact_argument_substitution_mode,
            deploy_artifact_source=oci.dev_ops.DeployArtifactDeployArtifactSourceArgs(
                deploy_artifact_source_type=deploy_artifact_deploy_artifact_source_deploy_artifact_source_type,
                base64encoded_content=deploy_artifact_deploy_artifact_source_base64encoded_content,
                chart_url=deploy_artifact_deploy_artifact_source_chart_url,
                deploy_artifact_path=deploy_artifact_deploy_artifact_source_deploy_artifact_path,
                deploy_artifact_version=deploy_artifact_deploy_artifact_source_deploy_artifact_version,
                helm_artifact_source_type=deploy_artifact_deploy_artifact_source_helm_artifact_source_type,
                helm_verification_key_source=oci.dev_ops.DeployArtifactDeployArtifactSourceHelmVerificationKeySourceArgs(
                    verification_key_source_type=deploy_artifact_deploy_artifact_source_helm_verification_key_source_verification_key_source_type,
                    current_public_key=deploy_artifact_deploy_artifact_source_helm_verification_key_source_current_public_key,
                    previous_public_key=deploy_artifact_deploy_artifact_source_helm_verification_key_source_previous_public_key,
                    vault_secret_id=test_secret["id"],
                ),
                image_digest=deploy_artifact_deploy_artifact_source_image_digest,
                image_uri=deploy_artifact_deploy_artifact_source_image_uri,
                repository_id=test_repository["id"],
            ),
            deploy_artifact_type=deploy_artifact_deploy_artifact_type,
            project_id=test_project["id"],
            defined_tags={
                "foo-namespace.bar-key": "value",
            },
            description=deploy_artifact_description,
            display_name=deploy_artifact_display_name,
            freeform_tags={
                "bar-key": "value",
            })
        ```

        ## Import

        DeployArtifacts can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:DevOps/deployArtifact:DeployArtifact test_deploy_artifact "id"
        ```

        :param str resource_name: The name of the resource.
        :param DeployArtifactArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DeployArtifactArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 argument_substitution_mode: Optional[pulumi.Input[str]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 deploy_artifact_source: Optional[pulumi.Input[pulumi.InputType['DeployArtifactDeployArtifactSourceArgs']]] = None,
                 deploy_artifact_type: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 project_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DeployArtifactArgs.__new__(DeployArtifactArgs)

            if argument_substitution_mode is None and not opts.urn:
                raise TypeError("Missing required property 'argument_substitution_mode'")
            __props__.__dict__["argument_substitution_mode"] = argument_substitution_mode
            __props__.__dict__["defined_tags"] = defined_tags
            if deploy_artifact_source is None and not opts.urn:
                raise TypeError("Missing required property 'deploy_artifact_source'")
            __props__.__dict__["deploy_artifact_source"] = deploy_artifact_source
            if deploy_artifact_type is None and not opts.urn:
                raise TypeError("Missing required property 'deploy_artifact_type'")
            __props__.__dict__["deploy_artifact_type"] = deploy_artifact_type
            __props__.__dict__["description"] = description
            __props__.__dict__["display_name"] = display_name
            __props__.__dict__["freeform_tags"] = freeform_tags
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
            __props__.__dict__["compartment_id"] = None
            __props__.__dict__["lifecycle_details"] = None
            __props__.__dict__["state"] = None
            __props__.__dict__["system_tags"] = None
            __props__.__dict__["time_created"] = None
            __props__.__dict__["time_updated"] = None
        super(DeployArtifact, __self__).__init__(
            'oci:DevOps/deployArtifact:DeployArtifact',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            argument_substitution_mode: Optional[pulumi.Input[str]] = None,
            compartment_id: Optional[pulumi.Input[str]] = None,
            defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            deploy_artifact_source: Optional[pulumi.Input[pulumi.InputType['DeployArtifactDeployArtifactSourceArgs']]] = None,
            deploy_artifact_type: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            display_name: Optional[pulumi.Input[str]] = None,
            freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            lifecycle_details: Optional[pulumi.Input[str]] = None,
            project_id: Optional[pulumi.Input[str]] = None,
            state: Optional[pulumi.Input[str]] = None,
            system_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            time_created: Optional[pulumi.Input[str]] = None,
            time_updated: Optional[pulumi.Input[str]] = None) -> 'DeployArtifact':
        """
        Get an existing DeployArtifact resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] argument_substitution_mode: (Updatable) Mode for artifact parameter substitution. Options: `"NONE", "SUBSTITUTE_PLACEHOLDERS"` For Helm Deployments only "NONE" is supported.
        :param pulumi.Input[str] compartment_id: The OCID of a compartment.
        :param pulumi.Input[Mapping[str, Any]] defined_tags: (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"foo-namespace.bar-key": "value"}`
        :param pulumi.Input[pulumi.InputType['DeployArtifactDeployArtifactSourceArgs']] deploy_artifact_source: (Updatable) Specifies source of an artifact.
        :param pulumi.Input[str] deploy_artifact_type: (Updatable) Type of the deployment artifact.
        :param pulumi.Input[str] description: (Updatable) Optional description about the deployment artifact.
        :param pulumi.Input[str] display_name: (Updatable) Deployment artifact display name. Avoid entering confidential information.
        :param pulumi.Input[Mapping[str, Any]] freeform_tags: (Updatable) Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.  See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"bar-key": "value"}`
        :param pulumi.Input[str] lifecycle_details: A detailed message describing the current state. For example, can be used to provide actionable information for a resource in Failed state.
        :param pulumi.Input[str] project_id: The OCID of a project.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        :param pulumi.Input[str] state: Current state of the deployment artifact.
        :param pulumi.Input[Mapping[str, Any]] system_tags: Usage of system tag keys. These predefined keys are scoped to namespaces. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"orcl-cloud.free-tier-retained": "true"}`
        :param pulumi.Input[str] time_created: Time the deployment artifact was created. Format defined by [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339).
        :param pulumi.Input[str] time_updated: Time the deployment artifact was updated. Format defined by [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339).
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DeployArtifactState.__new__(_DeployArtifactState)

        __props__.__dict__["argument_substitution_mode"] = argument_substitution_mode
        __props__.__dict__["compartment_id"] = compartment_id
        __props__.__dict__["defined_tags"] = defined_tags
        __props__.__dict__["deploy_artifact_source"] = deploy_artifact_source
        __props__.__dict__["deploy_artifact_type"] = deploy_artifact_type
        __props__.__dict__["description"] = description
        __props__.__dict__["display_name"] = display_name
        __props__.__dict__["freeform_tags"] = freeform_tags
        __props__.__dict__["lifecycle_details"] = lifecycle_details
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["state"] = state
        __props__.__dict__["system_tags"] = system_tags
        __props__.__dict__["time_created"] = time_created
        __props__.__dict__["time_updated"] = time_updated
        return DeployArtifact(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="argumentSubstitutionMode")
    def argument_substitution_mode(self) -> pulumi.Output[str]:
        """
        (Updatable) Mode for artifact parameter substitution. Options: `"NONE", "SUBSTITUTE_PLACEHOLDERS"` For Helm Deployments only "NONE" is supported.
        """
        return pulumi.get(self, "argument_substitution_mode")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> pulumi.Output[str]:
        """
        The OCID of a compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> pulumi.Output[Mapping[str, Any]]:
        """
        (Updatable) Defined tags for this resource. Each key is predefined and scoped to a namespace. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"foo-namespace.bar-key": "value"}`
        """
        return pulumi.get(self, "defined_tags")

    @property
    @pulumi.getter(name="deployArtifactSource")
    def deploy_artifact_source(self) -> pulumi.Output['outputs.DeployArtifactDeployArtifactSource']:
        """
        (Updatable) Specifies source of an artifact.
        """
        return pulumi.get(self, "deploy_artifact_source")

    @property
    @pulumi.getter(name="deployArtifactType")
    def deploy_artifact_type(self) -> pulumi.Output[str]:
        """
        (Updatable) Type of the deployment artifact.
        """
        return pulumi.get(self, "deploy_artifact_type")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        (Updatable) Optional description about the deployment artifact.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Output[str]:
        """
        (Updatable) Deployment artifact display name. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> pulumi.Output[Mapping[str, Any]]:
        """
        (Updatable) Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.  See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"bar-key": "value"}`
        """
        return pulumi.get(self, "freeform_tags")

    @property
    @pulumi.getter(name="lifecycleDetails")
    def lifecycle_details(self) -> pulumi.Output[str]:
        """
        A detailed message describing the current state. For example, can be used to provide actionable information for a resource in Failed state.
        """
        return pulumi.get(self, "lifecycle_details")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[str]:
        """
        The OCID of a project.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[str]:
        """
        Current state of the deployment artifact.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="systemTags")
    def system_tags(self) -> pulumi.Output[Mapping[str, Any]]:
        """
        Usage of system tag keys. These predefined keys are scoped to namespaces. See [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm). Example: `{"orcl-cloud.free-tier-retained": "true"}`
        """
        return pulumi.get(self, "system_tags")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> pulumi.Output[str]:
        """
        Time the deployment artifact was created. Format defined by [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339).
        """
        return pulumi.get(self, "time_created")

    @property
    @pulumi.getter(name="timeUpdated")
    def time_updated(self) -> pulumi.Output[str]:
        """
        Time the deployment artifact was updated. Format defined by [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339).
        """
        return pulumi.get(self, "time_updated")

