# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetNetworkFirewallPolicyMappedSecretsResult',
    'AwaitableGetNetworkFirewallPolicyMappedSecretsResult',
    'get_network_firewall_policy_mapped_secrets',
    'get_network_firewall_policy_mapped_secrets_output',
]

@pulumi.output_type
class GetNetworkFirewallPolicyMappedSecretsResult:
    """
    A collection of values returned by getNetworkFirewallPolicyMappedSecrets.
    """
    def __init__(__self__, display_name=None, id=None, mapped_secret_summary_collections=None, network_firewall_policy_id=None):
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if mapped_secret_summary_collections and not isinstance(mapped_secret_summary_collections, list):
            raise TypeError("Expected argument 'mapped_secret_summary_collections' to be a list")
        pulumi.set(__self__, "mapped_secret_summary_collections", mapped_secret_summary_collections)
        if network_firewall_policy_id and not isinstance(network_firewall_policy_id, str):
            raise TypeError("Expected argument 'network_firewall_policy_id' to be a str")
        pulumi.set(__self__, "network_firewall_policy_id", network_firewall_policy_id)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[str]:
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="mappedSecretSummaryCollections")
    def mapped_secret_summary_collections(self) -> Sequence['outputs.GetNetworkFirewallPolicyMappedSecretsMappedSecretSummaryCollectionResult']:
        """
        The list of mapped_secret_summary_collection.
        """
        return pulumi.get(self, "mapped_secret_summary_collections")

    @property
    @pulumi.getter(name="networkFirewallPolicyId")
    def network_firewall_policy_id(self) -> str:
        return pulumi.get(self, "network_firewall_policy_id")


class AwaitableGetNetworkFirewallPolicyMappedSecretsResult(GetNetworkFirewallPolicyMappedSecretsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNetworkFirewallPolicyMappedSecretsResult(
            display_name=self.display_name,
            id=self.id,
            mapped_secret_summary_collections=self.mapped_secret_summary_collections,
            network_firewall_policy_id=self.network_firewall_policy_id)


def get_network_firewall_policy_mapped_secrets(display_name: Optional[str] = None,
                                               network_firewall_policy_id: Optional[str] = None,
                                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNetworkFirewallPolicyMappedSecretsResult:
    """
    This data source provides the list of Network Firewall Policy Mapped Secrets in Oracle Cloud Infrastructure Network Firewall service.

    Returns a list of Mapped Secret for the Network Firewall Policy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_firewall_policy_mapped_secrets = oci.NetworkFirewall.get_network_firewall_policy_mapped_secrets(network_firewall_policy_id=test_network_firewall_policy["id"],
        display_name=network_firewall_policy_mapped_secret_display_name)
    ```


    :param str display_name: A filter to return only resources that match the entire display name given.
    :param str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    __args__ = dict()
    __args__['displayName'] = display_name
    __args__['networkFirewallPolicyId'] = network_firewall_policy_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:NetworkFirewall/getNetworkFirewallPolicyMappedSecrets:getNetworkFirewallPolicyMappedSecrets', __args__, opts=opts, typ=GetNetworkFirewallPolicyMappedSecretsResult).value

    return AwaitableGetNetworkFirewallPolicyMappedSecretsResult(
        display_name=pulumi.get(__ret__, 'display_name'),
        id=pulumi.get(__ret__, 'id'),
        mapped_secret_summary_collections=pulumi.get(__ret__, 'mapped_secret_summary_collections'),
        network_firewall_policy_id=pulumi.get(__ret__, 'network_firewall_policy_id'))


@_utilities.lift_output_func(get_network_firewall_policy_mapped_secrets)
def get_network_firewall_policy_mapped_secrets_output(display_name: Optional[pulumi.Input[Optional[str]]] = None,
                                                      network_firewall_policy_id: Optional[pulumi.Input[str]] = None,
                                                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetNetworkFirewallPolicyMappedSecretsResult]:
    """
    This data source provides the list of Network Firewall Policy Mapped Secrets in Oracle Cloud Infrastructure Network Firewall service.

    Returns a list of Mapped Secret for the Network Firewall Policy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_firewall_policy_mapped_secrets = oci.NetworkFirewall.get_network_firewall_policy_mapped_secrets(network_firewall_policy_id=test_network_firewall_policy["id"],
        display_name=network_firewall_policy_mapped_secret_display_name)
    ```


    :param str display_name: A filter to return only resources that match the entire display name given.
    :param str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    ...
