# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetNetworkFirewallPolicyServiceResult',
    'AwaitableGetNetworkFirewallPolicyServiceResult',
    'get_network_firewall_policy_service',
    'get_network_firewall_policy_service_output',
]

@pulumi.output_type
class GetNetworkFirewallPolicyServiceResult:
    """
    A collection of values returned by getNetworkFirewallPolicyService.
    """
    def __init__(__self__, id=None, name=None, network_firewall_policy_id=None, parent_resource_id=None, port_ranges=None, type=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if network_firewall_policy_id and not isinstance(network_firewall_policy_id, str):
            raise TypeError("Expected argument 'network_firewall_policy_id' to be a str")
        pulumi.set(__self__, "network_firewall_policy_id", network_firewall_policy_id)
        if parent_resource_id and not isinstance(parent_resource_id, str):
            raise TypeError("Expected argument 'parent_resource_id' to be a str")
        pulumi.set(__self__, "parent_resource_id", parent_resource_id)
        if port_ranges and not isinstance(port_ranges, list):
            raise TypeError("Expected argument 'port_ranges' to be a list")
        pulumi.set(__self__, "port_ranges", port_ranges)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the service.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkFirewallPolicyId")
    def network_firewall_policy_id(self) -> str:
        return pulumi.get(self, "network_firewall_policy_id")

    @property
    @pulumi.getter(name="parentResourceId")
    def parent_resource_id(self) -> str:
        """
        OCID of the Network Firewall Policy this service belongs to.
        """
        return pulumi.get(self, "parent_resource_id")

    @property
    @pulumi.getter(name="portRanges")
    def port_ranges(self) -> Sequence['outputs.GetNetworkFirewallPolicyServicePortRangeResult']:
        """
        List of port-ranges used.
        """
        return pulumi.get(self, "port_ranges")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Describes the type of Service.
        """
        return pulumi.get(self, "type")


class AwaitableGetNetworkFirewallPolicyServiceResult(GetNetworkFirewallPolicyServiceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNetworkFirewallPolicyServiceResult(
            id=self.id,
            name=self.name,
            network_firewall_policy_id=self.network_firewall_policy_id,
            parent_resource_id=self.parent_resource_id,
            port_ranges=self.port_ranges,
            type=self.type)


def get_network_firewall_policy_service(name: Optional[str] = None,
                                        network_firewall_policy_id: Optional[str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNetworkFirewallPolicyServiceResult:
    """
    This data source provides details about a specific Network Firewall Policy Service resource in Oracle Cloud Infrastructure Network Firewall service.

    Get Service by the given name in the context of network firewall policy.


    :param str name: Name of the service.
    :param str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['networkFirewallPolicyId'] = network_firewall_policy_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:NetworkFirewall/getNetworkFirewallPolicyService:getNetworkFirewallPolicyService', __args__, opts=opts, typ=GetNetworkFirewallPolicyServiceResult).value

    return AwaitableGetNetworkFirewallPolicyServiceResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        network_firewall_policy_id=pulumi.get(__ret__, 'network_firewall_policy_id'),
        parent_resource_id=pulumi.get(__ret__, 'parent_resource_id'),
        port_ranges=pulumi.get(__ret__, 'port_ranges'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_network_firewall_policy_service)
def get_network_firewall_policy_service_output(name: Optional[pulumi.Input[str]] = None,
                                               network_firewall_policy_id: Optional[pulumi.Input[str]] = None,
                                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetNetworkFirewallPolicyServiceResult]:
    """
    This data source provides details about a specific Network Firewall Policy Service resource in Oracle Cloud Infrastructure Network Firewall service.

    Get Service by the given name in the context of network firewall policy.


    :param str name: Name of the service.
    :param str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    ...
