# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetNetworkFirewallPolicyServiceListResult',
    'AwaitableGetNetworkFirewallPolicyServiceListResult',
    'get_network_firewall_policy_service_list',
    'get_network_firewall_policy_service_list_output',
]

@pulumi.output_type
class GetNetworkFirewallPolicyServiceListResult:
    """
    A collection of values returned by getNetworkFirewallPolicyServiceList.
    """
    def __init__(__self__, id=None, name=None, network_firewall_policy_id=None, parent_resource_id=None, services=None, total_services=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if network_firewall_policy_id and not isinstance(network_firewall_policy_id, str):
            raise TypeError("Expected argument 'network_firewall_policy_id' to be a str")
        pulumi.set(__self__, "network_firewall_policy_id", network_firewall_policy_id)
        if parent_resource_id and not isinstance(parent_resource_id, str):
            raise TypeError("Expected argument 'parent_resource_id' to be a str")
        pulumi.set(__self__, "parent_resource_id", parent_resource_id)
        if services and not isinstance(services, list):
            raise TypeError("Expected argument 'services' to be a list")
        pulumi.set(__self__, "services", services)
        if total_services and not isinstance(total_services, int):
            raise TypeError("Expected argument 'total_services' to be a int")
        pulumi.set(__self__, "total_services", total_services)

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the service Group.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkFirewallPolicyId")
    def network_firewall_policy_id(self) -> str:
        return pulumi.get(self, "network_firewall_policy_id")

    @property
    @pulumi.getter(name="parentResourceId")
    def parent_resource_id(self) -> str:
        """
        OCID of the Network Firewall Policy this serviceList belongs to.
        """
        return pulumi.get(self, "parent_resource_id")

    @property
    @pulumi.getter
    def services(self) -> Sequence[str]:
        """
        List of services in the group.
        """
        return pulumi.get(self, "services")

    @property
    @pulumi.getter(name="totalServices")
    def total_services(self) -> int:
        """
        Count of total services in the given service List.
        """
        return pulumi.get(self, "total_services")


class AwaitableGetNetworkFirewallPolicyServiceListResult(GetNetworkFirewallPolicyServiceListResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNetworkFirewallPolicyServiceListResult(
            id=self.id,
            name=self.name,
            network_firewall_policy_id=self.network_firewall_policy_id,
            parent_resource_id=self.parent_resource_id,
            services=self.services,
            total_services=self.total_services)


def get_network_firewall_policy_service_list(name: Optional[str] = None,
                                             network_firewall_policy_id: Optional[str] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNetworkFirewallPolicyServiceListResult:
    """
    This data source provides details about a specific Network Firewall Policy Service List resource in Oracle Cloud Infrastructure Network Firewall service.

    Get ServiceList by the given name in the context of network firewall policy.


    :param str name: Name of the service Group.
    :param str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['networkFirewallPolicyId'] = network_firewall_policy_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:NetworkFirewall/getNetworkFirewallPolicyServiceList:getNetworkFirewallPolicyServiceList', __args__, opts=opts, typ=GetNetworkFirewallPolicyServiceListResult).value

    return AwaitableGetNetworkFirewallPolicyServiceListResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        network_firewall_policy_id=pulumi.get(__ret__, 'network_firewall_policy_id'),
        parent_resource_id=pulumi.get(__ret__, 'parent_resource_id'),
        services=pulumi.get(__ret__, 'services'),
        total_services=pulumi.get(__ret__, 'total_services'))


@_utilities.lift_output_func(get_network_firewall_policy_service_list)
def get_network_firewall_policy_service_list_output(name: Optional[pulumi.Input[str]] = None,
                                                    network_firewall_policy_id: Optional[pulumi.Input[str]] = None,
                                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetNetworkFirewallPolicyServiceListResult]:
    """
    This data source provides details about a specific Network Firewall Policy Service List resource in Oracle Cloud Infrastructure Network Firewall service.

    Get ServiceList by the given name in the context of network firewall policy.


    :param str name: Name of the service Group.
    :param str network_firewall_policy_id: Unique Network Firewall Policy identifier
    """
    ...
