# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetNetworkLoadBalancersPoliciesResult',
    'AwaitableGetNetworkLoadBalancersPoliciesResult',
    'get_network_load_balancers_policies',
    'get_network_load_balancers_policies_output',
]

@pulumi.output_type
class GetNetworkLoadBalancersPoliciesResult:
    """
    A collection of values returned by getNetworkLoadBalancersPolicies.
    """
    def __init__(__self__, filters=None, id=None, network_load_balancers_policy_collections=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if network_load_balancers_policy_collections and not isinstance(network_load_balancers_policy_collections, list):
            raise TypeError("Expected argument 'network_load_balancers_policy_collections' to be a list")
        pulumi.set(__self__, "network_load_balancers_policy_collections", network_load_balancers_policy_collections)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetNetworkLoadBalancersPoliciesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="networkLoadBalancersPolicyCollections")
    def network_load_balancers_policy_collections(self) -> Sequence['outputs.GetNetworkLoadBalancersPoliciesNetworkLoadBalancersPolicyCollectionResult']:
        """
        The list of network_load_balancers_policy_collection.
        """
        return pulumi.get(self, "network_load_balancers_policy_collections")


class AwaitableGetNetworkLoadBalancersPoliciesResult(GetNetworkLoadBalancersPoliciesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNetworkLoadBalancersPoliciesResult(
            filters=self.filters,
            id=self.id,
            network_load_balancers_policy_collections=self.network_load_balancers_policy_collections)


def get_network_load_balancers_policies(filters: Optional[Sequence[pulumi.InputType['GetNetworkLoadBalancersPoliciesFilterArgs']]] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNetworkLoadBalancersPoliciesResult:
    """
    This data source provides the list of Network Load Balancers Policies in Oracle Cloud Infrastructure Network Load Balancer service.

    Lists the available network load balancer policies.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_load_balancers_policies = oci.NetworkLoadBalancer.get_network_load_balancers_policies()
    ```
    """
    __args__ = dict()
    __args__['filters'] = filters
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:NetworkLoadBalancer/getNetworkLoadBalancersPolicies:getNetworkLoadBalancersPolicies', __args__, opts=opts, typ=GetNetworkLoadBalancersPoliciesResult).value

    return AwaitableGetNetworkLoadBalancersPoliciesResult(
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        network_load_balancers_policy_collections=pulumi.get(__ret__, 'network_load_balancers_policy_collections'))


@_utilities.lift_output_func(get_network_load_balancers_policies)
def get_network_load_balancers_policies_output(filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetNetworkLoadBalancersPoliciesFilterArgs']]]]] = None,
                                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetNetworkLoadBalancersPoliciesResult]:
    """
    This data source provides the list of Network Load Balancers Policies in Oracle Cloud Infrastructure Network Load Balancer service.

    Lists the available network load balancer policies.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_network_load_balancers_policies = oci.NetworkLoadBalancer.get_network_load_balancers_policies()
    ```
    """
    ...
