# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ManagementStationRefreshManagementArgs', 'ManagementStationRefreshManagement']

@pulumi.input_type
class ManagementStationRefreshManagementArgs:
    def __init__(__self__, *,
                 management_station_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a ManagementStationRefreshManagement resource.
        :param pulumi.Input[str] management_station_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the management station.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        pulumi.set(__self__, "management_station_id", management_station_id)

    @property
    @pulumi.getter(name="managementStationId")
    def management_station_id(self) -> pulumi.Input[str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the management station.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "management_station_id")

    @management_station_id.setter
    def management_station_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "management_station_id", value)


@pulumi.input_type
class _ManagementStationRefreshManagementState:
    def __init__(__self__, *,
                 management_station_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ManagementStationRefreshManagement resources.
        :param pulumi.Input[str] management_station_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the management station.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        if management_station_id is not None:
            pulumi.set(__self__, "management_station_id", management_station_id)

    @property
    @pulumi.getter(name="managementStationId")
    def management_station_id(self) -> Optional[pulumi.Input[str]]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the management station.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "management_station_id")

    @management_station_id.setter
    def management_station_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "management_station_id", value)


class ManagementStationRefreshManagement(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 management_station_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource provides the Management Station Refresh Management resource in Oracle Cloud Infrastructure Os Management Hub service.

        Refreshes the list of software sources mirrored by the management station to support the associated instances.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_management_station_refresh_management = oci.os_management_hub.ManagementStationRefreshManagement("test_management_station_refresh_management", management_station_id=test_management_station["id"])
        ```

        ## Import

        ManagementStationRefreshManagement can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:OsManagementHub/managementStationRefreshManagement:ManagementStationRefreshManagement test_management_station_refresh_management "id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] management_station_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the management station.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ManagementStationRefreshManagementArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Management Station Refresh Management resource in Oracle Cloud Infrastructure Os Management Hub service.

        Refreshes the list of software sources mirrored by the management station to support the associated instances.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_management_station_refresh_management = oci.os_management_hub.ManagementStationRefreshManagement("test_management_station_refresh_management", management_station_id=test_management_station["id"])
        ```

        ## Import

        ManagementStationRefreshManagement can be imported using the `id`, e.g.

        ```sh
        $ pulumi import oci:OsManagementHub/managementStationRefreshManagement:ManagementStationRefreshManagement test_management_station_refresh_management "id"
        ```

        :param str resource_name: The name of the resource.
        :param ManagementStationRefreshManagementArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ManagementStationRefreshManagementArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 management_station_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ManagementStationRefreshManagementArgs.__new__(ManagementStationRefreshManagementArgs)

            if management_station_id is None and not opts.urn:
                raise TypeError("Missing required property 'management_station_id'")
            __props__.__dict__["management_station_id"] = management_station_id
        super(ManagementStationRefreshManagement, __self__).__init__(
            'oci:OsManagementHub/managementStationRefreshManagement:ManagementStationRefreshManagement',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            management_station_id: Optional[pulumi.Input[str]] = None) -> 'ManagementStationRefreshManagement':
        """
        Get an existing ManagementStationRefreshManagement resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] management_station_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the management station.
               
               
               ** IMPORTANT **
               Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ManagementStationRefreshManagementState.__new__(_ManagementStationRefreshManagementState)

        __props__.__dict__["management_station_id"] = management_station_id
        return ManagementStationRefreshManagement(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="managementStationId")
    def management_station_id(self) -> pulumi.Output[str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the management station.


        ** IMPORTANT **
        Any change to a property that does not support update will force the destruction and recreation of the resource with the new property values
        """
        return pulumi.get(self, "management_station_id")

