# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetProcessSetsResult',
    'AwaitableGetProcessSetsResult',
    'get_process_sets',
    'get_process_sets_output',
]

@pulumi.output_type
class GetProcessSetsResult:
    """
    A collection of values returned by getProcessSets.
    """
    def __init__(__self__, compartment_id=None, display_name=None, filters=None, id=None, process_set_collections=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if process_set_collections and not isinstance(process_set_collections, list):
            raise TypeError("Expected argument 'process_set_collections' to be a list")
        pulumi.set(__self__, "process_set_collections", process_set_collections)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[str]:
        """
        Name of the Process Set.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetProcessSetsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="processSetCollections")
    def process_set_collections(self) -> Sequence['outputs.GetProcessSetsProcessSetCollectionResult']:
        """
        The list of process_set_collection.
        """
        return pulumi.get(self, "process_set_collections")


class AwaitableGetProcessSetsResult(GetProcessSetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProcessSetsResult(
            compartment_id=self.compartment_id,
            display_name=self.display_name,
            filters=self.filters,
            id=self.id,
            process_set_collections=self.process_set_collections)


def get_process_sets(compartment_id: Optional[str] = None,
                     display_name: Optional[str] = None,
                     filters: Optional[Sequence[pulumi.InputType['GetProcessSetsFilterArgs']]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProcessSetsResult:
    """
    This data source provides the list of Process Sets in Oracle Cloud Infrastructure Stack Monitoring service.

    API to get the details of all Process Sets.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_process_sets = oci.StackMonitoring.get_process_sets(compartment_id=compartment_id,
        display_name=process_set_display_name)
    ```


    :param str compartment_id: The ID of the compartment in which data is listed.
    :param str display_name: A filter to return only resources that match the entire display name given.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:StackMonitoring/getProcessSets:getProcessSets', __args__, opts=opts, typ=GetProcessSetsResult).value

    return AwaitableGetProcessSetsResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        display_name=pulumi.get(__ret__, 'display_name'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        process_set_collections=pulumi.get(__ret__, 'process_set_collections'))


@_utilities.lift_output_func(get_process_sets)
def get_process_sets_output(compartment_id: Optional[pulumi.Input[str]] = None,
                            display_name: Optional[pulumi.Input[Optional[str]]] = None,
                            filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetProcessSetsFilterArgs']]]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProcessSetsResult]:
    """
    This data source provides the list of Process Sets in Oracle Cloud Infrastructure Stack Monitoring service.

    API to get the details of all Process Sets.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_process_sets = oci.StackMonitoring.get_process_sets(compartment_id=compartment_id,
        display_name=process_set_display_name)
    ```


    :param str compartment_id: The ID of the compartment in which data is listed.
    :param str display_name: A filter to return only resources that match the entire display name given.
    """
    ...
